import java.io.File;
import java.io.FileInputStream;
import java.io.InputStream;

import org.apache.poi.hssf.usermodel.HSSFCell;
import org.apache.poi.hssf.usermodel.HSSFRichTextString;
import org.apache.poi.hssf.usermodel.HSSFRow;
import org.apache.poi.hssf.usermodel.HSSFSheet;
import org.apache.poi.hssf.usermodel.HSSFWorkbook;

public class MissingFontProblem {

	public static void main(String[] args) throws Exception{
		// get the file
		File xlsFile = new File("Example.xls");
		InputStream inp = new FileInputStream(xlsFile);
		// get the offending cell from the workbook
		HSSFWorkbook workbook = new HSSFWorkbook(inp);
		HSSFSheet sheet = workbook.getSheetAt(0);
		HSSFRow row = sheet.getRow(0);
		HSSFCell cell = row.getCell(0);
		// get the text from that cell (I know it is a rich text string)
		HSSFRichTextString rtString = cell.getRichStringCellValue();
		
		// print out the text
		System.out.println(rtString);
		
		// print out all of the formatting runs
		System.out.println("BEFORE USING APPLY FONT: [string-index, font-index]");
		for(int i=0; i<rtString.numFormattingRuns(); i++)
			System.out.println(rtString.getIndexOfFormattingRun(i)+","+rtString.getFontOfFormattingRun(i));
		
		// Apply a font that ends just where the next font begins
		rtString.applyFont(0, rtString.getIndexOfFormattingRun(0), HSSFRichTextString.NO_FONT);
		
		// print out all of the formatting runs AGAIN
		System.out.println("BEFORE USING APPLY FONT: [string-index, font-index]");
		for(int i=0; i<rtString.numFormattingRuns(); i++)
			System.out.println(rtString.getIndexOfFormattingRun(i)+","+rtString.getFontOfFormattingRun(i));
	}
	
}
